#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#      dos.py
#
#      Copyright 2014 Recursos Python - www.recursospython.com
#
#

import stackless
import stacklesssocket; stacklesssocket.install()

from socket import socket, error as socket_error
from sys import stdout


MSG_ESTABLISHED = 0
MSG_REFUSED = 1


def get_number(prompt):
    number = None
    while True:
        try:
            number = int(raw_input(prompt))
        except ValueError:
            pass
        else:
            break
    return number


def worker(id, channel):
    while True:
        s = socket()
        try:
            s.connect(("localhost", 6030))
        except socket_error as e:
            channel.send(MSG_REFUSED)
        else:
            channel.send(MSG_ESTABLISHED)
        s.close()


def listener(channel):
    established = 0
    refused = 0
    
    while True:
        message = channel.receive()
        if message == MSG_ESTABLISHED:
            established += 1
        elif message == MSG_REFUSED:
            refused += 1
        stdout.write("\r%d attempts (%d established, %d refused)." %
                     (established + refused, established, refused))


def main():
    count = get_number("Number of workers: ")
    
    channel = stackless.channel()
    stackless.tasklet(listener)(channel)
    
    for i in range(count):
        stackless.tasklet(worker)(i, channel)
    
    try:
        stackless.run()
    except KeyboardInterrupt:
        # Terminate.
        stdout.write("\n\r")


if __name__ == "__main__":
    main()